SystemOrganization addCategory: #'Pacman-Cells'!
SystemOrganization addCategory: #Pacman!

StringButtonMorph subclass: #MyStartButton
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pacman'!

!MyStartButton methodsFor: 'initialization' stamp: 'cl 6/19/2012 13:25'!
game: aGame
	game := aGame.! !

!MyStartButton methodsFor: 'event handling' stamp: 'cl 6/19/2012 13:22'!
handlesMouseUp: anEvent
	^true.! !

!MyStartButton methodsFor: 'initialization' stamp: 'cl 6/19/2012 13:20'!
initialize
	super initialize.
	self contents: 'start Game!!'.
	self position: 220@120.! !

!MyStartButton methodsFor: 'event handling' stamp: 'cl 6/21/2012 13:47'!
mouseUp: anEvent
	game startGame.! !

Morph subclass: #PacmanCell
	instanceVariableNames: 'type game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pacman-Cells'!

PacmanCell subclass: #DotCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pacman-Cells'!

!DotCell methodsFor: 'eating' stamp: 'cl 6/21/2012 14:17'!
eatenBy: aPlayerCell
	"gets called when dot cell is eaten by aPlayerCell"
	game decreaseDots.
	aPlayerCell eatDot.
	^true.! !

!DotCell methodsFor: 'initialization' stamp: 'cl 6/19/2012 10:47'!
initialize
	super initialize.
	type := #DOT.
	self color: Color lightYellow.! !

!PacmanCell methodsFor: 'initialization' stamp: 'cl 6/21/2012 14:14'!
addGame: aGame
	"adds the Game the cell belongs to"
	game := aGame.! !

!PacmanCell methodsFor: 'eating' stamp: 'cl 6/20/2012 14:42'!
eatenBy: aPlayerCell
	"Aufruf, wenn die Zelle von einem Player gegessen wird"
	aPlayerCell eatNothing.
	^true.! !

!PacmanCell methodsFor: 'initialization' stamp: 'cl 6/19/2012 11:06'!
initialize
	"initialiser for PacmanCell"
	super initialize.
	self width: 20.
	self height: 20.
	self color: Color white.
	type := #BLANK.! !

PacmanCell subclass: #PlayerCell
	instanceVariableNames: 'direction currPos currPoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pacman-Cells'!

PlayerCell class
	instanceVariableNames: 'count'!

PlayerCell class
	instanceVariableNames: 'count'!

!PlayerCell methodsFor: 'accessing' stamp: 'BB 6/20/2012 11:25'!
currPoints
	"returns current points"
	^currPoints.! !

!PlayerCell methodsFor: 'accessing' stamp: 'cl 6/20/2012 17:53'!
currPoints: anInteger
	"sets the current points"
	currPoints := anInteger.! !

!PlayerCell methodsFor: 'accessing' stamp: 'BB 6/20/2012 11:24'!
currPos
	"returns current position"
	^currPos.! !

!PlayerCell methodsFor: 'accessing' stamp: 'BB 6/20/2012 11:24'!
currPos: aPosition
	"sets the current position"
	currPos := aPosition.! !

!PlayerCell methodsFor: 'accessing' stamp: 'cl 6/20/2012 15:32'!
direction
	"returns the current direction of this player cell"
	^direction.! !

!PlayerCell methodsFor: 'accessing' stamp: 'cl 6/20/2012 17:30'!
direction: aDirection
	"sets the direction this player should move"
	(aDirection = #UP) ifTrue: [
			"UP"
			direction := #UP.
			^self.
		].
	(aDirection = #DOWN) ifTrue: [
			"DOWN"
			direction := #DOWN.
			^self.
		].
	(aDirection = #LEFT) ifTrue: [
			"LEFT"
			direction := #LEFT.
			^self.
		].
	(aDirection = #RIGHT) ifTrue: [
			"RIGHT"
			direction := #RIGHT.
			^self.
		].
	(aDirection = #NO) ifTrue: [
			"NO direction"
			direction := #NO.
			^self.
		].! !

!PlayerCell methodsFor: 'eating' stamp: 'cl 6/20/2012 16:15'!
eatDot
	"gets called when player eats dot cell"
	currPoints := currPoints + 1.
	self eatNothing.! !

!PlayerCell methodsFor: 'eating' stamp: 'cl 6/20/2012 17:30'!
eatNothing
	"methods gets called when player cell eats nothing in current move"
	direction = #UP ifTrue: [
		currPos := currPos x @ (currPos y - 1).
		^self.
	].
	direction = #DOWN ifTrue: [
		currPos := currPos x @ (currPos y + 1).
		^self.
	].
	direction = #RIGHT ifTrue: [
		currPos := (currPos x + 1) @ currPos y.
		^self.
	].
	direction = #LEFT ifTrue: [
		currPos := (currPos x - 1) @ currPos y.
		^self.
	].! !

!PlayerCell methodsFor: 'eating' stamp: 'cl 6/21/2012 12:29'!
eatPlayer: aPlayerCell
	"gets called when player eats player cell"
	"returns true if self eats aPlayerCell, otherwise false"
	|otherCol otherDir eats|
	otherCol := aPlayerCell color.
	otherDir := aPlayerCell direction.
	
	"check if both players are colliding"
	((otherDir = #NO) |
	(direction = #LEFT & (otherDir = #RIGHT)) |
	(direction = #RIGHT & (otherDir = #LEFT)) |
	(direction = #UP & (otherDir = #DOWN)) |
	(direction = #DOWN & (otherDir = #UP))) ifFalse: [
		self eatNothing.
		^false.	
	].
			
	eats := false.
	"checks which player eats the other one"
	((self color = Color red) & (otherCol = Color blue)) |
	((self color = Color green) & (otherCol = Color red)) |
	((self color = Color blue) & (otherCol = Color green)) ifTrue: [
		eats := true.
	].
	
	eats ifTrue: [
		"self eats aPlayerCell"
		currPoints := currPoints + aPlayerCell currPoints.
		self eatNothing.
		"set other players values"
		aPlayerCell currPoints: 0.
		aPlayerCell currPos: -1 @ -1.
		aPlayerCell direction: #NO.
	] ifFalse: [
		"other player eats self"
		aPlayerCell currPoints: aPlayerCell currPoints + currPoints.
		"set self values"
		currPoints := 0.
		currPos := -1 @ -1.
		direction := #NO.
	].

	^eats.! !

!PlayerCell methodsFor: 'eating' stamp: 'BB 6/20/2012 11:27'!
eatWall
	"gets called when player eats wallcell"
	direction := #NO.! !

!PlayerCell methodsFor: 'eating' stamp: 'cl 6/21/2012 12:12'!
eatenBy: aPlayerCell
	"aufgerufen wenn ein pacman einen anderen isst"
	aPlayerCell eatPlayer: self.
	^false.! !

!PlayerCell methodsFor: 'initialization' stamp: 'cl 6/21/2012 12:29'!
initialize
	super initialize.
	type := #PLAYER.
	direction := #NO.
	currPos := -1@ -1.
	currPoints := 0.! !

PacmanCell subclass: #WallCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pacman-Cells'!

!WallCell methodsFor: 'eating' stamp: 'cl 6/20/2012 14:41'!
eatenBy: aPlayerCell
	"gets called when wall cell is eaten by aPlayerCell in this move"
	aPlayerCell eatWall.
	^false.! !

!WallCell methodsFor: 'initialization' stamp: 'cl 6/19/2012 10:40'!
initialize
	super initialize.
	type := #WALL.
	self color: Color black.! !

StringMorph subclass: #StatusDisplay
	instanceVariableNames: 'text game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pacman'!

!StatusDisplay methodsFor: 'as yet unclassified' stamp: 'BB 6/21/2012 15:37'!
game: aGame
	game := aGame.! !

!StatusDisplay methodsFor: 'as yet unclassified' stamp: 'BB 6/21/2012 16:13'!
initialize
	super initialize.
	self contents: ''.
	self position: 220@350.
	self emphasis: 1.
	self color: Color blue.! !

Object subclass: #ParserResult
	instanceVariableNames: 'cells nrOfDots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pacman'!

!ParserResult methodsFor: 'accessing' stamp: 'cl 6/21/2012 14:04'!
cells
	^cells.! !

!ParserResult methodsFor: 'accessing' stamp: 'cl 6/21/2012 14:04'!
cells: aMatrix
	cells := aMatrix.! !

!ParserResult methodsFor: 'accessing' stamp: 'cl 6/21/2012 14:05'!
nrOfDots
	^nrOfDots.! !

!ParserResult methodsFor: 'accessing' stamp: 'cl 6/21/2012 14:05'!
nrOfDots: anInteger
	nrOfDots := anInteger.! !

Object subclass: #WorldParser
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pacman'!

!WorldParser methodsFor: 'initialization' stamp: 'cl 6/18/2012 18:17'!
addGame: aGame
	"adds Game to this parser"
	game := aGame.! !

!WorldParser methodsFor: 'initialization' stamp: 'cl 6/18/2012 20:10'!
initialize
	super initialize.
	game := nil.! !

!WorldParser methodsFor: 'fileParser' stamp: 'cl 6/21/2012 14:07'!
parseFileAt: filePath
	"parses the file at given path and returns a cell matrix"
	|file content cells i nrOfDots|
	file := (FileStream fileNamed: filePath) readOnly.
	
	content := file contentsOfEntireFile.
	nrOfDots := 0.
	
	i := 1.
	[i <= content lineCount] whileTrue: [
		|currentLine j c|
		currentLine := content lineNumber: i.
		"when accessing the first line create the matrix"
		(i = 1) ifTrue: [
			cells := Matrix rows: content lineCount columns: currentLine size.
			].
		
		"iterating over each character of the line"
		j := 1.
		[j <= currentLine size.] whileTrue: [
				|char|
				char := Character value: (currentLine byteAt: j).
				
				(char = $#) ifTrue: [
						"wall"
						c := WallCell new.
					] ifFalse: [
						(char = $.) ifTrue: [
								"dot"
								c := DotCell new.
								nrOfDots := nrOfDots + 1.
							] ifFalse: [
								(char = $1) ifTrue: [
										"player 1"
										c := PlayerCell new.
										c color: Color red.
										c currPos: j@i.
										game addPlayer: c WithId: 1.
									] ifFalse: [
										(char = $2) ifTrue: [
												"player 2"
												c := PlayerCell new.
												c color: Color blue.
												c currPos: j@i.
												game addPlayer: c WithId: 2.
											] ifFalse: [
												(char = $3) ifTrue: [
														"player 3"
														c := PlayerCell new.
														c color: Color green.
														c currPos: j@i.
														game addPlayer: c WithId: 3.
													] ifFalse: [
														"otherwise: blank field"
														c := PacmanCell new.
													].
											].
									].
							].
					].
				
				"add newly created cell to matrix and add it to game"
				cells at: i at: j put: c.
				game cell: c At: j At: i.
				j := j+1.
			].
		i := i+1.
	].
	
	file close.
	
	^(ParserResult new cells: cells; nrOfDots: nrOfDots).! !

BorderedMorph subclass: #PacmanGame
	instanceVariableNames: 'cells players timer dots levels status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pacman'!

!PacmanGame class methodsFor: 'as yet unclassified' stamp: 'cl 6/19/2012 14:16'!
maxPlayers
	"returns number of maximum players"
	^3.! !

!PacmanGame methodsFor: 'initialization' stamp: 'cl 6/21/2012 15:40'!
addPlayer: aPlayerCell WithId: anInteger
	"adds a player to this game, if not already exists
	returns trueif player was added, otherwise false"
	|player|
	(anInteger > PacmanGame maxPlayers) ifTrue: [
			"Id is greater than max players"
			^false.
		].
	
	player := players at: 1 at: anInteger.
	player ifNotNil: [
			"player already in players, set new color"
			aPlayerCell currPoints: player currPoints.
			aPlayerCell color: player color.
		].
	
	players at: 1 at: anInteger put: aPlayerCell.
	^true.! !

!PacmanGame methodsFor: 'logic' stamp: 'cl 6/21/2012 14:15'!
cell: c At: i At: j
	"creates a new cell with given offset"
	|origin|
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i-1) * c width) @ ((j-1) * c height) + origin.
	
	"adds this game to the cell"
	c addGame: self.
	! !

!PacmanGame methodsFor: 'logic' stamp: 'cl 6/20/2012 16:07'!
changeCellPosition: aCell
	"changes the position of the given cell to xValue and yValue"
	|origin|
	origin := self innerBounds origin.
	aCell position: ((aCell currPos x - 1) * aCell width) @ ((aCell currPos y - 1) * aCell height) + origin.! !

!PacmanGame methodsFor: 'logic' stamp: 'cl 6/21/2012 14:17'!
decreaseDots
	"decreases the dots by 1"
	dots = 0 ifFalse: [
		dots := dots - 1.
	].! !

!PacmanGame methodsFor: 'event handling' stamp: 'cl 6/19/2012 14:48'!
handlesKeyboard: anEvent
	^true.! !

!PacmanGame methodsFor: 'event handling' stamp: 'cl 6/19/2012 15:55'!
handlesMouseOver: anEvent
	^true.! !

!PacmanGame methodsFor: 'initialization' stamp: 'cl 6/21/2012 16:21'!
initialize
	|btnStart|
	super initialize.
	cells := nil.
	dots := nil.
	self bounds: (200@100 extent: (200@200)).
	self color: Color white.
	self borderColor: Color blue.
	
	players := Matrix rows: 1 columns: PacmanGame maxPlayers.
	
	btnStart := MyStartButton new game: self.
	self addMorph: btnStart.
	
	"add all levels to game queue"
	levels := OrderedCollection new.
	
	levels addLast: 'game1.txt'.
	levels addLast: 'game2.txt'.
	levels addLast: 'game3.txt'.
	
	"give game keyboard focus"
	ActiveHand newKeyboardFocus: self.! !

!PacmanGame methodsFor: 'event handling' stamp: 'cl 6/20/2012 17:28'!
keyStroke: anEvent
	"key Stroke event"
	|keyCode p|
	keyCode := anEvent keyValue.
	
	"Player 1"
	keyCode = 30 ifTrue: [
			"UP ARROW"
			p := players at: 1 at: 1.
			p direction: #UP.
		].
	
	keyCode = 31 ifTrue: [
			"DOWN ARROW"
			p := players at: 1 at: 1.
			p direction: #DOWN.
		].
	
	keyCode = 29 ifTrue: [
			"RIGHT ARROW"
			p := players at: 1 at: 1.
			p direction: #RIGHT.
		].
	
	keyCode = 28 ifTrue: [
			"LEFT ARROW"
			p := players at: 1 at: 1.
			p direction: #LEFT.
		].
	
	"Player 2"
	(keyCode = 119 | (keyCode = 87)) ifTrue: [
			"w or W -> UP"
			p := players at: 1 at: 2.
			p direction: #UP.
		].
	
	(keyCode = 115 | (keyCode = 83)) ifTrue: [
			"s or S -> DOWN"
			p := players at: 1 at: 2.
			p direction: #DOWN.
		].
	
	(keyCode = 100 | (keyCode = 68)) ifTrue: [
			"d or D -> RIGHT"
			p := players at: 1 at: 2.
			p direction: #RIGHT.
		].
	
	(keyCode = 97 | (keyCode = 65)) ifTrue: [
			"a or A -> LEFT"
			p := players at: 1 at: 2.
			p direction: #LEFT.
		].	

	"Player 3"
	(keyCode = 105 | (keyCode = 73)) ifTrue: [
			"i or I -> UP"
			p := players at: 1 at: 3.
			p direction: #UP.
		].
	
	(keyCode = 107 | (keyCode = 75)) ifTrue: [
			"k or K -> DOWN"
			p := players at: 1 at: 3.
			p direction: #DOWN.
		].
	
	(keyCode = 108 | (keyCode = 76)) ifTrue: [
			"l or L -> RIGHT"
			p := players at: 1 at: 3.
			p direction: #RIGHT.
		].
	
	(keyCode = 106 | (keyCode = 74)) ifTrue: [
			"j or J -> LEFT"
			p := players at: 1 at: 3.
			p direction: #LEFT.
		].	! !

!PacmanGame methodsFor: 'event handling' stamp: 'cl 6/19/2012 15:57'!
mouseEnter: anEvent
	"takes keyboardfocus if entered with mouse"
	ActiveHand newKeyboardFocus: self.! !

!PacmanGame methodsFor: 'logic' stamp: 'BB 6/21/2012 16:09'!
move
	"gets called everytime a move should be executed"
	|i|
	
	"calculate new position/next cell for each player"
	i := 1.
	[i <= PacmanGame maxPlayers] whileTrue: [
		|p pDir oldPos nextCell rmCell|
		p := players at: 1 at: i.
		
		"execute everything if player is not out of bounds"
		p currPos = (-1 @ -1) ifFalse: [
	
			"copy current direction as it could change due to concurrent calls"
			pDir := p direction copy.
		
			"save old player position"
			oldPos := p currPos clone.
		
			"get new cell for player"
			pDir = #UP ifTrue: [
				nextCell := cells at: (oldPos y - 1) at: oldPos x.
			] ifFalse: [
				pDir = #DOWN ifTrue: [
					nextCell := cells at: (oldPos y + 1) at: oldPos x.
				] ifFalse: [
					pDir = #RIGHT ifTrue: [
						nextCell := cells at: oldPos y at: (oldPos x + 1).
					] ifFalse: [
						pDir = #LEFT ifTrue: [
							nextCell := cells at: oldPos y at: (oldPos x - 1).
						] ifFalse: [
							"no movement of player cell"
							nextCell := nil.
						].
					].
				].
			].
			
			"if player cell is in movement"
			nextCell ifNotNil: [
				"let player eat nextCell"
				rmCell := nextCell eatenBy: p.
			
				rmCell ifTrue: [
					"was dot cell or normal cell"
					self removeMorph: nextCell.
				].
		
				"if position of player has changed, add new normal cell to old position"
				(oldPos = p currPos) ifFalse: [
					|newCell j playerAtOldPosition|
					playerAtOldPosition := false.
					"check if playercell has not moved to old position"
					j := 1.
					[j <= (i-1)] whileTrue: [
						|p1|
						p1 := players at: 1 at: j.
						"if already a player at old position"
						playerAtOldPosition ifFalse: [
							playerAtOldPosition := (oldPos = p1 currPos).
						].
						j := j+1.
					].
					playerAtOldPosition ifFalse: [
						newCell := PacmanCell new.
						self cell: newCell At: oldPos x At: oldPos y.
						cells at: oldPos y at: oldPos x put: newCell.
					].
				].
			].
		].
					
		"remove player cell from and matrix"
		(p currPos = (-1 @ -1)) ifTrue: [
			self removeMorph: p.
		] ifFalse: [
			"move player cell to new position"
			self changeCellPosition: p.
			cells at: p currPos y at: p currPos x put: p.
		].
	
		i := i + 1.
	].
! !

!PacmanGame methodsFor: 'logic' stamp: 'BB 6/21/2012 16:07'!
printCurrentStatus
	"prints the current status to the screen"
	|textInformation|
	textInformation := StatusDisplay new game: self.
	self addMorph: textInformation.
	status := textInformation.! !

!PacmanGame methodsFor: 'logic' stamp: 'cl 6/21/2012 13:55'!
remainingPlayers
	"returns the number of remaining players. between 1 and PacmanGame maxPlayers"
	|i rp|
	rp := 0.
	i := 1.
	[i <= PacmanGame maxPlayers] whileTrue: [
		|p|
		p := players at: 1 at: i.
		
		p currPos = (-1 @ -1) ifFalse: [
			rp := rp + 1.
		].
		
		i := i + 1.
	].

	^rp.! !

!PacmanGame methodsFor: 'logic' stamp: 'BB 6/21/2012 16:46'!
startGame
	"starts a new game"
	self removeAllMorphs.
	
	"retrieve next level to process"
	(levels size = 0) ifTrue: [
		"end of game"
		|p1 p2 p3 txt|
		p1 := (players at: 1 at: 1) currPoints.
		p2 := (players at: 1 at: 2) currPoints.
		p3 := (players at: 1 at: 3) currPoints.
		
		self height: 200.
		self width: 200.
		
		txt := StringMorph new.
		txt contents: 'End of Game'.
		txt position: self position + (20@20).
		self addMorph: txt.
		
		txt := StringMorph new.
		txt contents: ('Player 1: ',p1).
		txt position: self position + (20@50).
		self addMorph: txt.
		
		txt := StringMorph new.
		txt contents: ('Player 2: ',p2).
		txt position: self position + (20@80).
		self addMorph: txt.
		
		txt := StringMorph new.
		txt contents: ('Player 3: ',p3).
		txt position: self position + (20@110).
		self addMorph: txt.
		
		
	] ifFalse: [
		"end of level -> load next"
		|parser c retVal lvl|
		
		parser := WorldParser new addGame: self.
		
		lvl := levels at: 1.
		levels removeFirst.
	
		retVal := parser parseFileAt: lvl.
		cells := retVal cells.
		dots := retVal nrOfDots.
		"get one cell"
		c := cells at: 1 at: 1.
	
		self height: (cells rowCount * c height) + (2 * self borderWidth)+50.
		self width: (cells columnCount * c width) + (2 * self borderWidth).
		
		self printCurrentStatus.
		status position: (self position x + 20) @ (self position y + (self height - 40)).
		self startMoving.
	].! !

!PacmanGame methodsFor: 'logic' stamp: 'BB 6/21/2012 16:36'!
startMoving
	|process p1 p2 p3|
	
	self move.
	
	p1 := (players at: 1 at: 1).
	p2 := (players at: 1 at: 2).
	p3 := (players at: 1 at: 3).
	
	status contents: 'P1 (' , p1 color , '): ' , p1 currPoints , '      P2 (' , p2 color , '): ' , p2 currPoints , '    P3 (' , p3 color , '): ' , p3 currPoints , '    Dots left: ',dots.
	
	(15 atRandom = 1) ifTrue: [
		|c|
		c := p1 color.
		p1 color: p2 color.
		p2 color: p3 color.
		p3 color: c.
		].
	
	"abbruchbedingung"
    	(self remainingPlayers > 1 &
	(dots > 0))
	ifTrue: [
		process := [(Delay forMilliseconds: 250) wait. self startMoving.] newProcess.
		process resume.
	] ifFalse: [
		"level has ended"
		self startGame.
	].
! !
